without warning
include dll.e



global constant
	gdi=open_dll("gdi32"),
	user=open_dll("user32"),
	kernel=open_dll("kernel32"),
	DeleteDC_=define_c_func(gdi,"DeleteDC",{C_INT},C_INT),
	GetDesktopWindow_=define_c_func(user,"GetDesktopWindow",{},C_INT),
	GlobalLock_=define_c_func(kernel,"GlobalLock",{C_POINTER},C_POINTER),
	GlobalUnlock_=define_c_func(kernel,"GlobalUnlock",{C_POINTER},C_POINTER),
	CreateCompatibleDC_=define_c_func(gdi,"CreateCompatibleDC",{C_INT},C_POINTER),
	CreateDIBSection_=define_c_func(gdi,"CreateDIBSection",{C_INT,C_POINTER,C_UINT,C_POINTER,C_INT,C_UINT},C_POINTER),
	SelectObject_=define_c_func(gdi,"SelectObject",{C_INT,C_INT},C_INT),
	DeleteObject_=define_c_func(gdi,"DeleteObject",{C_POINTER},C_INT),
	GetObject_=define_c_func(gdi,"GetObjectA",{C_INT,C_INT,C_POINTER},C_INT),
	BitBlt_=define_c_func(gdi,"BitBlt",repeat(C_INT,8)&C_UINT,C_INT),
	EnumWindows_=define_c_func(user,"EnumWindows",{C_POINTER,C_POINTER},C_INT),
	GetClassName_=define_c_func(user,"GetClassNameA",{C_INT,C_POINTER,C_INT},C_INT),
	GetWindowText_=define_c_func(user,"GetWindowTextA",{C_INT,C_POINTER,C_INT},C_INT),
	GetWindowRect_=define_c_func(user,"GetWindowRect",{C_INT,C_POINTER},C_INT),
	GetDC_=define_c_func(user,"GetDC",{C_INT},C_POINTER),
	GetClientRect_=define_c_func(user,"GetClientRect",{C_INT,C_POINTER},C_INT),
	SizeOf_bmi_bmiHeader=40,
  biSize=0,--DWORD 
  biWidth=4,--LONG
  biHeight=8,--LONG
  biPlanes=12,--WORD
  biBitCount=14,--WORD
  biCompression=16,--DWORD
  biSizeImage=20,--DWORD
  biXPelsPerMeter=24,--LONG
  biYPelsPerMeter=28,--LONG
  biClrUsed=32,--DWORD
  biClrImportant=36,--DWORD
  BI_RGB=0,
  DIB_RGB_COLORS=0,
  SRCCOPY=#CC0020,
  bmType=0,--LONG
  bmWidth=4,--LONG
  bmHeight=8,--LONG
  bmWidthBytes=12,--LONG
  bmPlanes=16,--WORD
  bmBitsPixel=18,--WORD
  bmBits=20--LPVOID 24+40+8


sequence section_dc,section_mdc,section_bmi,section_bm,section_mbmp,section_width,section_height,section_bpp,section_bits

section_dc={}
section_mdc={}
section_bmi={}
section_bm={}
section_mbmp={}
section_width={}
section_height={}
section_bpp={}
section_bits={}

global procedure free_dib_section(atom bits)
	atom found,junk
	found=find(bits,section_bits)
	if not found then return end if
	junk=c_func(DeleteDC_,{section_mdc[found]})
	junk=c_func(GlobalUnlock_,{section_mbmp[found]})
	junk=c_func(DeleteObject_,{section_mbmp[found]})
	free(section_bm[found])
	free(section_bmi[found])
	section_dc=section_dc[1..found-1]&section_dc[found+1..$]
	section_mdc=section_mdc[1..found-1]&section_mdc[found+1..$]
	section_bmi=section_bmi[1..found-1]&section_bmi[found+1..$]
	section_bm=section_bm[1..found-1]&section_bm[found+1..$]
	section_mbmp=section_mbmp[1..found-1]&section_mbmp[found+1..$]
	section_width=section_width[1..found-1]&section_width[found+1..$]
	section_height=section_height[1..found-1]&section_height[found+1..$]
	section_bpp=section_bpp[1..found-1]&section_bpp[found+1..$]
	section_bits=section_bits[1..found-1]&section_bits[found+1..$]
end procedure

global function get_dib_width(atom bits)
	atom found
	found=find(bits,section_bits)
	if not found then return 0 end if
	return section_width[found]
end function

global function get_dib_height(atom bits)
	atom found
	found=find(bits,section_bits)
	if not found then return 0 end if
	return section_height[found]
end function

global function get_dib_width_height(atom bits)
	atom found
	found=find(bits,section_bits)
	if not found then return 0 end if
	return {section_width[found],section_height[found]}
end function

global function new_dib_section24(atom dc, atom width, atom height)
atom junk,hMemDC,bmi,bm,hMemBmp 
	if dc<=0 then return 0 end if

	hMemDC=c_func(CreateCompatibleDC_,{dc})
	bmi=allocate(40)
	bm=allocate(84)
	poke4(bmi+biSize,SizeOf_bmi_bmiHeader)
	poke4(bmi+biWidth,width)
	poke4(bmi+biHeight,-height)
	poke4(bmi+biPlanes,1)
	poke4(bmi+biBitCount,24)
	poke4(bmi+biCompression,BI_RGB)
	hMemBmp = c_func(CreateDIBSection_,{hMemDC, bmi, DIB_RGB_COLORS, 0, 0, 0})
	junk=c_func(GlobalLock_,{hMemBmp}) --puts(1,"GlobalLock_ ") ? junk
	junk=c_func(SelectObject_,{hMemDC,hMemBmp}) --puts(1,"SelectObject_ ") ? junk
	junk=c_func(GetObject_,{hMemBmp, 84, bm}) --puts(1,"GetObject_ ") ? junk  --? {peek4s(bm+bmWidth),peek4s(bm+bmHeight)}
	
	section_dc&=dc
	section_mdc&=hMemDC
	section_bmi&=bmi
	section_bm&=bm
	section_mbmp&=hMemBmp
	section_width&=width
	section_height&=height
	section_bpp&=24
	section_bits&=peek4u(bm+bmBits)
--	junk=c_func(BitBlt_,{hMemDC, 0, 0, peek4s(bm+bmWidth), peek4s(bm+bmHeight), hDC, rect[1], rect[2], SRCCOPY}) --puts(1,"BitBlt_ ") ? junk

--	junk=c_func(DeleteDC_,{hMemDC})
--	junk=c_func(GlobalUnlock_,{hMemBmp})
--	junk=c_func(DeleteObject_,{hMemBmp})
--	free(bm)
--	free(bmi)
	return peek4u(bm+bmBits)
end function

global function new_dib_section32(atom dc, atom width, atom height)
atom junk,hMemDC,bmi,bm,hMemBmp 
	if dc<=0 then return 0 end if
	hMemDC=c_func(CreateCompatibleDC_,{dc})
	bmi=allocate(40)
	bm=allocate(84)
	poke4(bmi+biSize,SizeOf_bmi_bmiHeader)
	poke4(bmi+biWidth,width)
	poke4(bmi+biHeight,-height)
	poke4(bmi+biPlanes,1)
	poke4(bmi+biBitCount,32)
	poke4(bmi+biCompression,BI_RGB)
	hMemBmp = c_func(CreateDIBSection_,{hMemDC, bmi, DIB_RGB_COLORS, 0, 0, 0})
	junk=c_func(GlobalLock_,{hMemBmp}) --puts(1,"GlobalLock_ ") ? junk
	junk=c_func(SelectObject_,{hMemDC,hMemBmp}) --puts(1,"SelectObject_ ") ? junk
	junk=c_func(GetObject_,{hMemBmp, 84, bm}) --puts(1,"GetObject_ ") ? junk  --? {peek4s(bm+bmWidth),peek4s(bm+bmHeight)}
	
	section_dc&=dc
	section_mdc&=hMemDC
	section_bmi&=bmi
	section_bm&=bm
	section_mbmp&=hMemBmp
	section_width&=width
	section_height&=height
	section_bpp&=32
	section_bits&=peek4u(bm+bmBits)
--	junk=c_func(BitBlt_,{hMemDC, 0, 0, peek4s(bm+bmWidth), peek4s(bm+bmHeight), hDC, rect[1], rect[2], SRCCOPY}) --puts(1,"BitBlt_ ") ? junk

--	junk=c_func(DeleteDC_,{hMemDC})
--	junk=c_func(GlobalUnlock_,{hMemBmp})
--	junk=c_func(DeleteObject_,{hMemBmp})
--	free(bm)
--	free(bmi)
	return peek4u(bm+bmBits)
end function

global function dib_section_to_dc_bitblt(atom bits,sequence dst, sequence src)
atom found
	found=find(bits,section_bits)
	if not found then return 1 end if
	return c_func(BitBlt_,{section_dc[found], dst[1], dst[2], dst[3], dst[4], section_mdc[found], src[1], src[2], SRCCOPY}) --puts(1,"BitBlt_ ") ? junk
end function

global function dc_to_dib_section_bitblt(atom bits,sequence dst, sequence src)
atom found
	found=find(bits,section_bits)
	if not found then return 1 end if
	return c_func(BitBlt_,{section_mdc[found], dst[1], dst[2], dst[3], dst[4], section_dc[found], src[1], src[2], SRCCOPY}) --puts(1,"BitBlt_ ") ? junk
end function

global function dc_cap(atom bits)
atom found
	found=find(bits,section_bits)
	if not found then return 1 end if
	return c_func(BitBlt_,{section_mdc[found], 0,0, section_width[found],section_height[found], section_dc[found], 0,0, SRCCOPY}) --puts(1,"BitBlt_ ") ? junk
end function
