--sendrightclick,senddoublerightclick,sendleftclick,newgame


constant around={{-1,-1},{0,-1},{1,-1},{-1,0},{1,0},{-1,1},{0,1},{1,1}}

function count_1s(atom a)
	sequence b
	b=int_to_bits(a,8)
	a=0
	for i = 1 to length(b) do
		a+=b[i]
	end for
	return a
end function
sequence pos

function rem_end(atom a)
	sequence b
	atom f
	b=reverse(int_to_bits(a,8))
	f=find(1,b)
	b=reverse(b[f..$])
	return length(b)
end function

pos=repeat(repeat({},8),8)
for i = 1 to 255 do
	pos[count_1s(i)][rem_end(i)]&=i
end for

global function board_logic(sequence tiles)
atom num_unchecked,is_bomb,possible_bombs_around,unfound_bombs
atom width,height
atom ax,ay,a_unchecked,a_nbombs--aroundx aroundy around_unchecked around_number_bombs
sequence is_definitely_a_bomb,possibly_bombs,is_definitely_not_a_bomb,is_questionable_bomb,unfound_numbers
sequence tmap--test map
	if length(tiles)=0 then return {} end if
	width=length(tiles[1])
	height=length(tiles)
	unfound_bombs=0
	possible_bombs_around=0
	num_unchecked=0
	is_definitely_a_bomb={}
	is_definitely_not_a_bomb={}
	is_questionable_bomb={}
	unfound_numbers={}
	for y = 1 to height do
	for x = 1 to width do
		num_unchecked+=find(tiles[y][x],"uq")!=0
		if find(tiles[y][x],"fo") then return {{1,1,newgame}} end if--found or other bomb
		if find(tiles[y][x],"12345678") then
			a_nbombs=find(tiles[y][x],"12345678")
			a_unchecked=0
			possibly_bombs={}
			for a = 1 to length(around) do
				ax=around[a][1]+x ay=around[a][2]+y
				if ax>=1 and ay>=1 and ax<=width and ay<=height then
					if find(tiles[ay][ax],"uq") then a_unchecked+=1 possibly_bombs=append(possibly_bombs,{ax,ay}) end if
					if tiles[ay][ax]='l' then a_nbombs-=1 end if--'l' is a flag, for a found bomb
				end if
			end for
			if a_unchecked=a_nbombs and length(possibly_bombs) then--only if the number of bombs is the same as the number of unchecked squares is it definitely a bomb
				for i = 1 to length(possibly_bombs) do
					if tiles[possibly_bombs[i][2]][possibly_bombs[i][1]]='q' then
						possibly_bombs[i]&=senddoublerightclick
					else
						possibly_bombs[i]&=sendrightclick
					end if
					if not find(possibly_bombs[i],is_definitely_a_bomb) then
						is_definitely_a_bomb=append(is_definitely_a_bomb,possibly_bombs[i])
					end if
				end for
			elsif length(possibly_bombs) and a_nbombs=0 then--unchecked squares with all bombs accounted for can't be bombs
				for i = 1 to length(possibly_bombs) do
					possibly_bombs[i]&=sendleftclick
					if not find(possibly_bombs[i],is_definitely_not_a_bomb) then
						is_definitely_not_a_bomb=append(is_definitely_not_a_bomb,possibly_bombs[i])
					end if
				end for
			elsif length(possibly_bombs)>a_nbombs and a_nbombs>0 then--more unchecked then bombs so don't quite know for sure, should always be the last rule
				possible_bombs_around+=length(possibly_bombs)
				unfound_bombs+=a_nbombs
				unfound_numbers=append(unfound_numbers,{x,y,a_nbombs})
				for i = 1 to length(possibly_bombs) do
					if tiles[possibly_bombs[i][2]][possibly_bombs[i][1]]='q' then
						possibly_bombs[i]&=do_nothing
					else
						possibly_bombs[i]&=senddoublerightclick
						if not find(possibly_bombs[i],is_questionable_bomb) then
							is_questionable_bomb=append(is_questionable_bomb,possibly_bombs[i])
						end if
					end if
				end for
			end if
		end if
	end for
	end for
	sleep(1)
	if num_unchecked=width*height then return {{rand(width),rand(height),sendleftclick}} end if
	if length(is_definitely_a_bomb) then return is_definitely_a_bomb end if
	if length(is_definitely_not_a_bomb) then return is_definitely_not_a_bomb end if
	if length(is_questionable_bomb) then return is_questionable_bomb end if
--	? possible_bombs_around/unfound_bombs
	return {}
end function
